diff --git a/src/main/java/net/minecraft/core/block/entity/BlockEntity.java b/src/main/java/net/minecraft/core/block/entity/TileEntity.java
similarity index 96%
rename from src/main/java/net/minecraft/core/block/entity/BlockEntity.java
rename to src/main/java/net/minecraft/core/block/entity/TileEntity.java
index ee82ac748..85f29fc2e 100644
--- a/src/main/java/net/minecraft/core/block/entity/BlockEntity.java
+++ b/src/main/java/net/minecraft/core/block/entity/TileEntity.java
@@ -12,10 +12,9 @@ import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.ICarriable;
 import net.minecraft.core.world.World;
-import net.minecraft.core.world.chunk.Chunk;
 import org.jetbrains.annotations.Nullable;
 
-public class BlockEntity implements ICarriable
+public class TileEntity implements ICarriable
 {
     public @Nullable World worldObj; // Null when loading data from nbt and null when held by entity
     public @Nullable CarriedBlock carriedBlock;
@@ -24,7 +23,7 @@ public class BlockEntity implements ICarriable
     public int z;
     protected boolean tileEntityInvalid;
 
-    public BlockEntity()
+    public TileEntity()
     {
     }
 
@@ -103,7 +102,7 @@ public class BlockEntity implements ICarriable
 
     public void writeToNBT(CompoundTag nbttagcompound)
     {
-        String name = BlockEntityDispatcher.getIDFromClass(getClass());
+        String name = TileEntityDispatcher.getIDFromClass(getClass());
         if(name == null)
         {
             throw new RuntimeException(getClass() + " is missing a mapping! This is a bug!");
diff --git a/src/main/java/net/minecraft/core/block/entity/ActivatorBlockEntity.java b/src/main/java/net/minecraft/core/block/entity/TileEntityActivator.java
similarity index 95%
rename from src/main/java/net/minecraft/core/block/entity/ActivatorBlockEntity.java
rename to src/main/java/net/minecraft/core/block/entity/TileEntityActivator.java
index f7f773848..dd6b623f9 100644
--- a/src/main/java/net/minecraft/core/block/entity/ActivatorBlockEntity.java
+++ b/src/main/java/net/minecraft/core/block/entity/TileEntityActivator.java
@@ -3,10 +3,10 @@ package net.minecraft.core.block.entity;
 import com.mojang.nbt.CompoundTag;
 import com.mojang.nbt.ListTag;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.RotatableBlock;
+import net.minecraft.core.block.BlockRotatable;
 import net.minecraft.core.block.motion.CarriedBlock;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.ItemEntity;
+import net.minecraft.core.entity.EntityItem;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.player.inventory.container.Container;
@@ -15,14 +15,14 @@ import net.minecraft.core.world.World;
 
 import java.util.Random;
 
-public class ActivatorBlockEntity extends BlockEntity implements Container {
+public class TileEntityActivator extends TileEntity implements Container {
     public static final int CONTAINER_SIZE = 9;
     private ItemStack[] dispenserContents;
     private final Random random;
     public short lockedSlotBitSet;
     public int stackSelector = 0;
 
-    public ActivatorBlockEntity()
+    public TileEntityActivator()
     {
         dispenserContents = new ItemStack[CONTAINER_SIZE];
         random = new Random();
@@ -217,7 +217,7 @@ public class ActivatorBlockEntity extends BlockEntity implements Container {
                     i1 = itemstack.stackSize;
                 }
                 itemstack.stackSize -= i1;
-                ItemEntity item = new ItemEntity(world, (float) x + f, (float) y + f1, (float) z + f2, new ItemStack(itemstack.itemID, i1, itemstack.getMetadata()));
+                EntityItem item = new EntityItem(world, (float) x + f, (float) y + f1, (float) z + f2, new ItemStack(itemstack.itemID, i1, itemstack.getMetadata()));
                 float f3 = 0.05F;
                 item.xd = (float) random.nextGaussian() * f3;
                 item.yd = (float) random.nextGaussian() * f3 + 0.2F;
@@ -234,6 +234,6 @@ public class ActivatorBlockEntity extends BlockEntity implements Container {
 
     @Override
     public CarriedBlock getCarriedEntry(World world, Entity holder, Block currentBlock, int currentMeta) {
-        return super.getCarriedEntry(world, holder, currentBlock, RotatableBlock.setDirection(currentMeta, Direction.NORTH) /*Reset rotation, primarily to make it render in hand properly*/);
+        return super.getCarriedEntry(world, holder, currentBlock, BlockRotatable.setDirection(currentMeta, Direction.NORTH) /*Reset rotation, primarily to make it render in hand properly*/);
     }
 }
diff --git a/src/main/java/net/minecraft/core/block/entity/BasketBlockEntity.java b/src/main/java/net/minecraft/core/block/entity/TileEntityBasket.java
similarity index 97%
rename from src/main/java/net/minecraft/core/block/entity/BasketBlockEntity.java
rename to src/main/java/net/minecraft/core/block/entity/TileEntityBasket.java
index 5d0c24185..46d19805d 100644
--- a/src/main/java/net/minecraft/core/block/entity/BasketBlockEntity.java
+++ b/src/main/java/net/minecraft/core/block/entity/TileEntityBasket.java
@@ -4,7 +4,7 @@ import java.util.*;
 
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.ItemEntity;
+import net.minecraft.core.entity.EntityItem;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
@@ -15,7 +15,7 @@ import net.minecraft.core.net.packet.BlockEntityDataPacket;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 
-public class BasketBlockEntity extends BlockEntity
+public class TileEntityBasket extends TileEntity
 {
     private int numUnitsInside = 0;
     private final Map<BasketEntry, Integer> contents = new HashMap<>();
@@ -60,7 +60,7 @@ public class BasketBlockEntity extends BlockEntity
             return;
         }
 
-        final ItemEntity item = new ItemEntity(workingWorld, x + f, y + f1, z + f2, itemstack);
+        final EntityItem item = new EntityItem(workingWorld, x + f, y + f1, z + f2, itemstack);
         final float f3 = 0.05F;
         item.xd = (float) rand.nextGaussian() * f3;
         item.yd = (float) rand.nextGaussian() * f3 + 0.25F;
@@ -142,7 +142,7 @@ public class BasketBlockEntity extends BlockEntity
 
         final AABB aabb = AABB.getTemporaryBB(posX, posY, posZ, posX + 1, posY + 2, posZ + 1);
 
-        final List<Entity> entities = workingWorld.getEntitiesWithinAABB(ItemEntity.class, aabb);
+        final List<Entity> entities = workingWorld.getEntitiesWithinAABB(EntityItem.class, aabb);
 
         boolean shouldUpdate = false;
 
@@ -150,7 +150,7 @@ public class BasketBlockEntity extends BlockEntity
         {
             for (final Entity e : entities)
             {
-                final ItemEntity entity = (ItemEntity) e;
+                final EntityItem entity = (EntityItem) e;
                 if (entity.item != null && entity.item.stackSize > 0 && entity.basketPickupDelay == 0)
                 {
                     shouldUpdate = importItemStack(entity.item);
diff --git a/src/main/java/net/minecraft/core/block/entity/ChestBlockEntity.java b/src/main/java/net/minecraft/core/block/entity/TileEntityChest.java
similarity index 91%
rename from src/main/java/net/minecraft/core/block/entity/ChestBlockEntity.java
rename to src/main/java/net/minecraft/core/block/entity/TileEntityChest.java
index 2d34a4b72..3b7846a7b 100644
--- a/src/main/java/net/minecraft/core/block/entity/ChestBlockEntity.java
+++ b/src/main/java/net/minecraft/core/block/entity/TileEntityChest.java
@@ -2,15 +2,15 @@ package net.minecraft.core.block.entity;
 
 
 // Referenced classes of package net.minecraft.src:
-//            BlockEntity, IInventory, ItemStack, NBTTagCompound,
+//            TileEntity, IInventory, ItemStack, NBTTagCompound,
 //            NBTTagList, World, Player
 
 import com.mojang.logging.LogUtils;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.ChestBlock;
+import net.minecraft.core.block.BlockChest;
 import net.minecraft.core.block.motion.CarriedBlock;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.ItemEntity;
+import net.minecraft.core.entity.EntityItem;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.player.inventory.container.Container;
@@ -21,12 +21,12 @@ import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.world.World;
 import org.slf4j.Logger;
 
-public class ChestBlockEntity extends BlockEntity
+public class TileEntityChest extends TileEntity
     implements Container
 {
     private static final Logger LOGGER = LogUtils.getLogger();
 
-    public ChestBlockEntity()
+    public TileEntityChest()
     {
         chestContents = new ItemStack[36];
     }
@@ -148,7 +148,7 @@ public class ChestBlockEntity extends BlockEntity
         for(int i = 0; i < this.getContainerSize(); i++) {
             ItemStack itemStack = this.getItem(i);
             if(itemStack == null) continue;
-            ItemEntity item = world.dropItem(x, y, z, itemStack);
+            EntityItem item = world.dropItem(x, y, z, itemStack);
             item.xd *= 0.5;
             item.yd *= 0.5;
             item.zd *= 0.5;
@@ -163,7 +163,7 @@ public class ChestBlockEntity extends BlockEntity
 
     @Override
     public CarriedBlock getCarriedEntry(World world, Entity holder, Block currentBlock, int currentMeta) {
-        return super.getCarriedEntry(world, holder, currentBlock, ChestBlock.getMetaWithDirection(ChestBlock.getMetaWithType(currentMeta, ChestBlock.Type.SINGLE), Direction.NORTH));
+        return super.getCarriedEntry(world, holder, currentBlock, BlockChest.getMetaWithDirection(BlockChest.getMetaWithType(currentMeta, BlockChest.Type.SINGLE), Direction.NORTH));
     }
 
     private ItemStack[] chestContents;
diff --git a/src/main/java/net/minecraft/core/block/entity/TileEntityDispatcher.java b/src/main/java/net/minecraft/core/block/entity/TileEntityDispatcher.java
new file mode 100644
index 000000000..d28ff8a4b
--- /dev/null
+++ b/src/main/java/net/minecraft/core/block/entity/TileEntityDispatcher.java
@@ -0,0 +1,85 @@
+package net.minecraft.core.block.entity;
+
+import com.mojang.logging.LogUtils;
+import com.mojang.nbt.CompoundTag;
+import net.minecraft.core.block.piston.TileEntityMovingPistonBlock;
+import org.slf4j.Logger;
+
+import java.util.HashMap;
+import java.util.Map;
+
+public class TileEntityDispatcher {
+    private static final Logger LOGGER = LogUtils.getLogger();
+
+    private static final Map<String, Class<? extends TileEntity>> nameToClassMap = new HashMap<>();
+    private static final Map<Class<? extends TileEntity>, String> classToNameMap = new HashMap<>();
+
+    public static void addMapping(Class<? extends TileEntity> entityClass, String name)
+    {
+        if(nameToClassMap.containsKey(name))
+        {
+            throw new IllegalArgumentException("Duplicate id: " + name);
+        } else
+        {
+            nameToClassMap.put(name, entityClass);
+            classToNameMap.put(entityClass, name);
+        }
+    }
+
+    public static TileEntity createAndLoadEntity(CompoundTag nbttagcompound)
+    {
+        TileEntity tileEntity = null;
+        Class<? extends TileEntity> entityClass = nameToClassMap.get(nbttagcompound.getString("id"));
+        try
+        {
+            if(entityClass != null)
+            {
+                tileEntity = entityClass.newInstance();
+            }
+        }
+        catch(Exception exception)
+        {
+            LOGGER.error("Exception when instancing class '{}'!", entityClass.getSimpleName(), exception);
+        }
+        if(tileEntity != null)
+        {
+            tileEntity.readFromNBT(nbttagcompound);
+        } else
+        {
+            LOGGER.warn("Skipping TileEntity with id {}", nbttagcompound.getString("id"));
+        }
+        return tileEntity;
+    }
+
+    public static Class<? extends TileEntity> getClassFromID(String id)
+    {
+        return nameToClassMap.get(id);
+    }
+
+    public static String getIDFromClass(Class<? extends TileEntity> clazz)
+    {
+        return classToNameMap.get(clazz);
+    }
+
+    static
+    {
+        // TODO make these ids namespaced
+        addMapping(TileEntityFurnace.class, "Furnace");
+        addMapping(TileEntityChest.class, "Chest");
+        addMapping(TileEntityJukebox.class, "RecordPlayer");
+        addMapping(TileEntityDispenser.class, "Trap");
+        addMapping(TileEntityActivator.class, "Activator");
+        addMapping(TileEntitySign.class, "Sign");
+        addMapping(TileEntityMobSpawner.class, "MobSpawner");
+        addMapping(TileEntityNoteblock.class, "Music");
+        addMapping(TileEntityMovingPistonBlock.class, "Piston");
+        addMapping(TileEntityFurnaceBlastFurnace.class, "BlastFurnace");
+        addMapping(TileEntitySensor.class, "Sensor");
+        addMapping(TileEntityTrommel.class, "Trommel");
+        addMapping(TileEntityBasket.class, "Basket");
+        addMapping(TileEntityFlag.class, "Flag");
+        addMapping(TileEntitySeat.class, "Seat");
+        addMapping(TileEntityFlowerJar.class, "FlowerJar");
+        addMapping(TileEntityMeshGold.class, "MeshGold");
+    }
+}
diff --git a/src/main/java/net/minecraft/core/block/entity/DispenserBlockEntity.java b/src/main/java/net/minecraft/core/block/entity/TileEntityDispenser.java
similarity index 95%
rename from src/main/java/net/minecraft/core/block/entity/DispenserBlockEntity.java
rename to src/main/java/net/minecraft/core/block/entity/TileEntityDispenser.java
index 5e02514dc..aaf5ebfb1 100644
--- a/src/main/java/net/minecraft/core/block/entity/DispenserBlockEntity.java
+++ b/src/main/java/net/minecraft/core/block/entity/TileEntityDispenser.java
@@ -1,10 +1,10 @@
 package net.minecraft.core.block.entity;
 
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.RotatableBlock;
+import net.minecraft.core.block.BlockRotatable;
 import net.minecraft.core.block.motion.CarriedBlock;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.ItemEntity;
+import net.minecraft.core.entity.EntityItem;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.IDispensable;
 import net.minecraft.core.item.ItemStack;
@@ -16,11 +16,11 @@ import net.minecraft.core.world.World;
 
 import java.util.Random;
 
-public class DispenserBlockEntity extends BlockEntity
+public class TileEntityDispenser extends TileEntity
     implements Container
 {
 
-    public DispenserBlockEntity()
+    public TileEntityDispenser()
     {
         dispenserContents = new ItemStack[9];
         random = new Random();
@@ -190,7 +190,7 @@ public class DispenserBlockEntity extends BlockEntity
                     i1 = itemstack.stackSize;
                 }
                 itemstack.stackSize -= i1;
-                ItemEntity entityitem = new ItemEntity(world, (float) x + f, (float) y + f1, (float) z + f2, new ItemStack(itemstack.itemID, i1, itemstack.getMetadata()));
+                EntityItem entityitem = new EntityItem(world, (float) x + f, (float) y + f1, (float) z + f2, new ItemStack(itemstack.itemID, i1, itemstack.getMetadata()));
                 float f3 = 0.05F;
                 entityitem.xd = (float) random.nextGaussian() * f3;
                 entityitem.yd = (float) random.nextGaussian() * f3 + 0.2F;
@@ -207,7 +207,7 @@ public class DispenserBlockEntity extends BlockEntity
 
     @Override
     public CarriedBlock getCarriedEntry(World world, Entity holder, Block currentBlock, int currentMeta) {
-        return super.getCarriedEntry(world, holder, currentBlock, RotatableBlock.setDirection(currentMeta, Direction.NORTH) /*Reset rotation, primarily to make it render in hand properly*/);
+        return super.getCarriedEntry(world, holder, currentBlock, BlockRotatable.setDirection(currentMeta, Direction.NORTH) /*Reset rotation, primarily to make it render in hand properly*/);
     }
 
     private ItemStack dispenserContents[];
diff --git a/src/main/java/net/minecraft/core/block/entity/FlagBlockEntity.java b/src/main/java/net/minecraft/core/block/entity/TileEntityFlag.java
similarity index 98%
rename from src/main/java/net/minecraft/core/block/entity/FlagBlockEntity.java
rename to src/main/java/net/minecraft/core/block/entity/TileEntityFlag.java
index 9dbd9fd2c..c5171fa06 100644
--- a/src/main/java/net/minecraft/core/block/entity/FlagBlockEntity.java
+++ b/src/main/java/net/minecraft/core/block/entity/TileEntityFlag.java
@@ -6,7 +6,6 @@ import java.util.UUID;
 import com.mojang.nbt.CompoundTag;
 import com.mojang.nbt.ListTag;
 
-import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
@@ -14,10 +13,9 @@ import net.minecraft.core.net.packet.Packet;
 import net.minecraft.core.net.packet.BlockEntityDataPacket;
 import net.minecraft.core.player.inventory.container.Container;
 import net.minecraft.core.util.helper.UUIDHelper;
-import net.minecraft.core.world.World;
 import org.jetbrains.annotations.Nullable;
 
-public class FlagBlockEntity extends BlockEntity
+public class TileEntityFlag extends TileEntity
     implements Container
 {
     public final int CANVAS_WIDTH = 24;
@@ -33,7 +31,7 @@ public class FlagBlockEntity extends BlockEntity
     
     public int sway = new Random().nextInt(100); // Random start value
     
-    public FlagBlockEntity()
+    public TileEntityFlag()
     {
     }
     
diff --git a/src/main/java/net/minecraft/core/block/entity/FlowerJarBlockEntity.java b/src/main/java/net/minecraft/core/block/entity/TileEntityFlowerJar.java
similarity index 83%
rename from src/main/java/net/minecraft/core/block/entity/FlowerJarBlockEntity.java
rename to src/main/java/net/minecraft/core/block/entity/TileEntityFlowerJar.java
index ed04eedf6..d5064de3d 100644
--- a/src/main/java/net/minecraft/core/block/entity/FlowerJarBlockEntity.java
+++ b/src/main/java/net/minecraft/core/block/entity/TileEntityFlowerJar.java
@@ -2,15 +2,14 @@ package net.minecraft.core.block.entity;
 
 import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.StackedFlowerBlock;
+import net.minecraft.core.block.BlockFlowerStackable;
 import net.minecraft.core.block.tag.BlockTags;
-import net.minecraft.core.entity.Entity;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.net.packet.Packet;
 import net.minecraft.core.net.packet.BlockEntityDataPacket;
 import net.minecraft.core.world.World;
 
-public class FlowerJarBlockEntity extends BlockEntity {
+public class TileEntityFlowerJar extends TileEntity {
 
     public int flowerInPot;
     public int flowerData;
@@ -36,8 +35,8 @@ public class FlowerJarBlockEntity extends BlockEntity {
         super.dropContents(world, x, y, z);
         if (flowerInPot > 0 && Block.hasTag(flowerInPot, BlockTags.PLANTABLE_IN_JAR)) {
             if (!world.isClientSide) {
-                if (Block.getBlock(flowerInPot) instanceof StackedFlowerBlock) {
-                    world.dropItem(x, y, z, new ItemStack(flowerInPot, StackedFlowerBlock.getStackCount(flowerData) + 1, 0));
+                if (Block.getBlock(flowerInPot) instanceof BlockFlowerStackable) {
+                    world.dropItem(x, y, z, new ItemStack(flowerInPot, BlockFlowerStackable.getStackCount(flowerData) + 1, 0));
                 } else {
                     world.dropItem(x, y, z, new ItemStack(flowerInPot, 1, flowerData));
                 }
diff --git a/src/main/java/net/minecraft/core/block/entity/FurnaceBlockEntity.java b/src/main/java/net/minecraft/core/block/entity/TileEntityFurnace.java
similarity index 94%
rename from src/main/java/net/minecraft/core/block/entity/FurnaceBlockEntity.java
rename to src/main/java/net/minecraft/core/block/entity/TileEntityFurnace.java
index 0ad75e482..931c4e392 100644
--- a/src/main/java/net/minecraft/core/block/entity/FurnaceBlockEntity.java
+++ b/src/main/java/net/minecraft/core/block/entity/TileEntityFurnace.java
@@ -2,21 +2,21 @@ package net.minecraft.core.block.entity;
 
 
 // Referenced classes of package net.minecraft.src:
-//            BlockEntity, IInventory, ItemStack, NBTTagCompound,
-//            NBTTagList, World, FurnaceBlock, FurnaceRecipes,
+//            TileEntity, IInventory, ItemStack, NBTTagCompound,
+//            NBTTagList, World, BlockFurnace, FurnaceRecipes,
 //            Item, Block, Material, Player
 
 import com.mojang.nbt.CompoundTag;
 import com.mojang.nbt.ListTag;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockFurnace;
 import net.minecraft.core.block.Blocks;
-import net.minecraft.core.block.FurnaceBlock;
 import net.minecraft.core.block.motion.CarriedBlock;
 import net.minecraft.core.crafting.LookupFuelFurnace;
 import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.data.registry.recipe.entry.RecipeEntryFurnace;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.ItemEntity;
+import net.minecraft.core.entity.EntityItem;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
@@ -29,12 +29,12 @@ import net.minecraft.core.world.World;
 import java.util.List;
 import java.util.Random;
 
-public class FurnaceBlockEntity extends BlockEntity
+public class TileEntityFurnace extends TileEntity
         implements Container
 {
     private final Random random;
 
-    public FurnaceBlockEntity()
+    public TileEntityFurnace()
     {
         random = new Random();
         furnaceItemStacks = new ItemStack[3];
@@ -312,7 +312,7 @@ public class FurnaceBlockEntity extends BlockEntity
 
     protected void updateFurnace(boolean forceLit){
         if (worldObj != null) {
-            FurnaceBlock.updateFurnaceBlockState( forceLit | (currentBurnTime > 0), worldObj, x, y, z);
+            BlockFurnace.updateFurnaceBlockState( forceLit | (currentBurnTime > 0), worldObj, x, y, z);
         } else if (carriedBlock != null) {
             carriedBlock.blockId = (forceLit | (currentBurnTime > 0)) ? Blocks.FURNACE_STONE_ACTIVE.id : Blocks.FURNACE_STONE_IDLE.id;
         }
@@ -338,7 +338,7 @@ public class FurnaceBlockEntity extends BlockEntity
     @Override
     public void dropContents(World world, int x, int y, int z) {
         super.dropContents(world, x, y, z);
-        if(!FurnaceBlock.keepFurnaceInventory)
+        if(!BlockFurnace.keepFurnaceInventory)
         {
             label0:
             for(int l = 0; l < this.getContainerSize(); l++)
@@ -363,12 +363,12 @@ public class FurnaceBlockEntity extends BlockEntity
                         i1 = itemstack.stackSize;
                     }
                     itemstack.stackSize -= i1;
-                    ItemEntity itemEntity = new ItemEntity(world, (float) x + f, (float) y + f1, (float) z + f2, new ItemStack(itemstack.itemID, i1, itemstack.getMetadata()));
+                    EntityItem entityItem = new EntityItem(world, (float) x + f, (float) y + f1, (float) z + f2, new ItemStack(itemstack.itemID, i1, itemstack.getMetadata()));
                     float f3 = 0.05F;
-                    itemEntity.xd = (float)random.nextGaussian() * f3;
-                    itemEntity.yd = (float)random.nextGaussian() * f3 + 0.2F;
-                    itemEntity.zd = (float)random.nextGaussian() * f3;
-                    world.entityJoinedWorld(itemEntity);
+                    entityItem.xd = (float)random.nextGaussian() * f3;
+                    entityItem.yd = (float)random.nextGaussian() * f3 + 0.2F;
+                    entityItem.zd = (float)random.nextGaussian() * f3;
+                    world.entityJoinedWorld(entityItem);
                 } while(true);
             }
 
diff --git a/src/main/java/net/minecraft/core/block/entity/BlastFurnaceBlockEntity.java b/src/main/java/net/minecraft/core/block/entity/TileEntityFurnaceBlastFurnace.java
similarity index 95%
rename from src/main/java/net/minecraft/core/block/entity/BlastFurnaceBlockEntity.java
rename to src/main/java/net/minecraft/core/block/entity/TileEntityFurnaceBlastFurnace.java
index f19d28083..5d29ca1ba 100644
--- a/src/main/java/net/minecraft/core/block/entity/BlastFurnaceBlockEntity.java
+++ b/src/main/java/net/minecraft/core/block/entity/TileEntityFurnaceBlastFurnace.java
@@ -2,13 +2,13 @@ package net.minecraft.core.block.entity;
 
 
 // Referenced classes of package net.minecraft.src:
-//            BlockEntity, IInventory, ItemStack, NBTTagCompound,
-//            NBTTagList, World, FurnaceBlock, FurnaceRecipes,
+//            TileEntity, IInventory, ItemStack, NBTTagCompound,
+//            NBTTagList, World, BlockFurnace, FurnaceRecipes,
 //            Item, Block, Material, Player
 
 import com.mojang.nbt.CompoundTag;
 import com.mojang.nbt.ListTag;
-import net.minecraft.core.block.BlastFurnaceBlock;
+import net.minecraft.core.block.BlockFurnaceBlast;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.crafting.LookupFuelFurnaceBlast;
 import net.minecraft.core.data.registry.Registries;
@@ -18,12 +18,12 @@ import net.minecraft.core.player.inventory.container.Container;
 
 import java.util.List;
 
-public class BlastFurnaceBlockEntity extends FurnaceBlockEntity
+public class TileEntityFurnaceBlastFurnace extends TileEntityFurnace
         implements Container
 {
 
 
-    public BlastFurnaceBlockEntity()
+    public TileEntityFurnaceBlastFurnace()
     {
         super();
         maxCookTime = 100;
@@ -144,7 +144,7 @@ public class BlastFurnaceBlockEntity extends FurnaceBlockEntity
     @Override
     protected void updateFurnace(boolean forceLit){
         if (worldObj != null) {
-            BlastFurnaceBlock.updateFurnaceBlockState(forceLit | (currentBurnTime > 0), worldObj, x, y, z);
+            BlockFurnaceBlast.updateFurnaceBlockState(forceLit | (currentBurnTime > 0), worldObj, x, y, z);
         } else if (carriedBlock != null) {
             carriedBlock.blockId = (forceLit | (currentBurnTime > 0)) ? Blocks.FURNACE_BLAST_ACTIVE.id : Blocks.FURNACE_BLAST_IDLE.id;
         }
diff --git a/src/main/java/net/minecraft/core/block/entity/JukeboxBlockEntity.java b/src/main/java/net/minecraft/core/block/entity/TileEntityJukebox.java
similarity index 89%
rename from src/main/java/net/minecraft/core/block/entity/JukeboxBlockEntity.java
rename to src/main/java/net/minecraft/core/block/entity/TileEntityJukebox.java
index 0c6fc6ebe..6fade50a7 100644
--- a/src/main/java/net/minecraft/core/block/entity/JukeboxBlockEntity.java
+++ b/src/main/java/net/minecraft/core/block/entity/TileEntityJukebox.java
@@ -2,19 +2,19 @@ package net.minecraft.core.block.entity;
 
 
 // Referenced classes of package net.minecraft.src:
-//            BlockEntity, NBTTagCompound
+//            TileEntity, NBTTagCompound
 
 import net.minecraft.core.block.Block;
-import net.minecraft.core.entity.ItemEntity;
+import net.minecraft.core.entity.EntityItem;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.world.LevelListener;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.save.conversion.ChunkConverter;
 import com.mojang.nbt.CompoundTag;
 
-public class JukeboxBlockEntity extends BlockEntity {
+public class TileEntityJukebox extends TileEntity {
     public int record;
-    public JukeboxBlockEntity() {
+    public TileEntityJukebox() {
     }
 
     @Override
@@ -49,7 +49,7 @@ public class JukeboxBlockEntity extends BlockEntity {
             double d = (double) (world.rand.nextFloat() * f) + (double) (1.0F - f) * 0.5D;
             double d1 = (double) (world.rand.nextFloat() * f) + (double) (1.0F - f) * 0.2D + 0.6D;
             double d2 = (double) (world.rand.nextFloat() * f) + (double) (1.0F - f) * 0.5D;
-            ItemEntity item = new ItemEntity(world, (double) x + d, (double) y + d1, (double) z + d2, new ItemStack(record, 1, 0));
+            EntityItem item = new EntityItem(world, (double) x + d, (double) y + d1, (double) z + d2, new ItemStack(record, 1, 0));
             item.pickupDelay = 10;
             world.entityJoinedWorld(item);
 
diff --git a/src/main/java/net/minecraft/core/block/entity/GoldMeshBlockEntity.java b/src/main/java/net/minecraft/core/block/entity/TileEntityMeshGold.java
similarity index 92%
rename from src/main/java/net/minecraft/core/block/entity/GoldMeshBlockEntity.java
rename to src/main/java/net/minecraft/core/block/entity/TileEntityMeshGold.java
index 144e26cab..4a072ba6d 100644
--- a/src/main/java/net/minecraft/core/block/entity/GoldMeshBlockEntity.java
+++ b/src/main/java/net/minecraft/core/block/entity/TileEntityMeshGold.java
@@ -1,7 +1,7 @@
 package net.minecraft.core.block.entity;
 
 import com.mojang.nbt.CompoundTag;
-import net.minecraft.core.entity.ItemEntity;
+import net.minecraft.core.entity.EntityItem;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.net.packet.Packet;
@@ -9,11 +9,11 @@ import net.minecraft.core.net.packet.BlockEntityDataPacket;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.Nullable;
 
-public class GoldMeshBlockEntity extends BlockEntity {
+public class TileEntityMeshGold extends TileEntity {
     @Nullable
     public ItemStack filterItem;
     public int ticksRan = 0;
-    public GoldMeshBlockEntity() {
+    public TileEntityMeshGold() {
     }
 
     public void tick()
@@ -69,7 +69,7 @@ public class GoldMeshBlockEntity extends BlockEntity {
     public void dropContents(World world, int x, int y, int z) {
         super.dropContents(world, x, y, z);
         if (filterItem != null){
-            ItemEntity item = world.dropItem(x, y, z, filterItem);
+            EntityItem item = world.dropItem(x, y, z, filterItem);
             item.xd *= 0.5;
             item.yd *= 0.5;
             item.zd *= 0.5;
diff --git a/src/main/java/net/minecraft/core/block/entity/MobSpawnerBlockEntity.java b/src/main/java/net/minecraft/core/block/entity/TileEntityMobSpawner.java
similarity index 97%
rename from src/main/java/net/minecraft/core/block/entity/MobSpawnerBlockEntity.java
rename to src/main/java/net/minecraft/core/block/entity/TileEntityMobSpawner.java
index 26be181a2..d24f2fdea 100644
--- a/src/main/java/net/minecraft/core/block/entity/MobSpawnerBlockEntity.java
+++ b/src/main/java/net/minecraft/core/block/entity/TileEntityMobSpawner.java
@@ -1,7 +1,6 @@
 package net.minecraft.core.block.entity;
 
 import com.mojang.logging.LogUtils;
-import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityDispatcher;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.enums.MobCategory;
@@ -11,12 +10,11 @@ import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.net.packet.Packet;
 import net.minecraft.core.net.packet.SetMobSpawnerPacket;
 import net.minecraft.core.entity.SpawnListEntry;
-import net.minecraft.core.world.World;
 import org.slf4j.Logger;
 
 import java.util.List;
 
-public class MobSpawnerBlockEntity extends BlockEntity
+public class TileEntityMobSpawner extends TileEntity
 {
     private static final Logger LOGGER = LogUtils.getLogger();
     public int delay;
@@ -25,7 +23,7 @@ public class MobSpawnerBlockEntity extends BlockEntity
     public double yaw2;
     private int nearby;
 
-    public MobSpawnerBlockEntity()
+    public TileEntityMobSpawner()
     {
         delay = -1;
         yaw2 = 0.0D;
